package APKPM::Gearman::Client;

use Moose::Role;

use Gearman::Client;
use JSON::XS;
use Data::Dump qw(dump);

requires 'server';

sub gc {
	my $self = shift;
	my $gc = Gearman::Client->new;
	$gc->job_servers( $self->server || 'localhost:4730' );
	warn "# Gearman server: ", dump( $gc->job_servers );
	return $gc;
}

sub do_background {
	my ( $self, $func, $args ) = @_;
	warn "# do_background ", dump( $func, $args );
	$self->gc->dispatch_background( $func, $args );
}

sub do_background_json {
	my ( $self, $func, $args ) = @_;
	warn "# do_background_json ", dump( $func, $args );
	$self->gc->dispatch_background( $func, JSON::XS::encode_json($args) );
}

sub do {
	my ( $self, $func, $args ) = @_;
	warn "# do ",dump( $func,$args );
	my $ret = $self->gc->do_task( $func, $args );
	warn "## $func $args = ",dump($ret);
	return JSON::XS::decode_json $$ret;
}

1;
